
DPL1     EQU   084h
DPH1     EQU   085h
DPS      EQU   086h
IN2BUF   XDATA 7E00H
PINSC    XDATA 7F9BH
OUT2BC   XDATA 7FC9H
OUT4BC   XDATA 7FCDH
AUTODATA XDATA 7FE5H

public		WritePortCReadX
public		WriteX

RAWIO2	SEGMENT	DATA
		rseg RAWIO2
last_num: DS 1

RAWIO	SEGMENT	CODE
;
		rseg RAWIO		;; locate the descriptor table in on-par
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; void WritePortCReadX(void);
;
; Trasnmit AUTODATAxOUT2BC with read PortC to Ep2IN buffer
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
WritePortCReadX:
	push DPL1
	push DPH1
;read transfer size
	mov  DPTR,#OUT4BC
	movx A,@DPTR ;data size
;
	mov  DPL1,#LOW  PINSC
	mov  DPH1,#HIGH PINSC
	mov  DPL,#LOW IN2BUF
;
	mov  last_num,A  ;save counter
	RRC  A
	RRC  A
	RRC  A
	ANL  A,#01FH
	JZ   WriteReadL
	mov  r7,A
;----- x8 bytes -----
WPCR1:
	push DPL
;
	mov  DPTR,#AUTODATA
;
	movx A,@DPTR  ;FWRITE
	inc  DPS
	movx A,@DPTR  ;PINSC
	inc  DPS
	mov  r0,a
;
	movx A,@DPTR  ;FWRITE
	inc  DPS
	movx A,@DPTR  ;PINSC
	inc  DPS
	mov  r1,a
;
	movx A,@DPTR  ;FWRITE
	inc  DPS
	movx A,@DPTR  ;PINSC
	inc  DPS
	mov  r2,a
;
	movx A,@DPTR  ;FWRITE
	inc  DPS
	movx A,@DPTR  ;PINSC
	inc  DPS
	mov  r3,a
;
	movx A,@DPTR  ;FWRITE
	inc  DPS
	movx A,@DPTR  ;PINSC
	inc  DPS
	mov  r4,a
;
	movx A,@DPTR  ;FWRITE
	inc  DPS
	movx A,@DPTR  ;PINSC
	inc  DPS
	mov  r5,a
;
	movx A,@DPTR  ;FWRITE
	inc  DPS
	movx A,@DPTR  ;PINSC
	inc  DPS
	mov  r6,a
;
	movx A,@DPTR  ;FWRITE
	inc  DPS
	movx A,@DPTR  ;PINSC
	inc  DPS
;
	pop  DPL
	dec  DPH   ;7F->7E == #HIGH IN2BUF
;
	xch  a,r0
	movx @DPTR,a
	inc  DPL
	mov  a,r1
	movx @DPTR,a
	inc  DPL
	mov  a,r2
	movx @DPTR,a
	inc  DPL
	mov  a,r3
	movx @DPTR,a
	inc  DPL
	mov  a,r4
	movx @DPTR,a
	inc  DPL
	mov  a,r5
	movx @DPTR,a
	inc  DPL
	mov  a,r6
	movx @DPTR,a
	inc  DPL
	mov  a,r0
	movx @DPTR,a
	inc  DPL
;
	djnz r7,WPCR1
;
;----- Last 1-7 bytes -----
WriteReadL:
	mov  A,last_num
	ANL  A,#07H
	JZ   WriteReadE
	mov  r7,A
WriteReadBI:
	push DPL
;
	mov  DPTR,#AUTODATA
	movx A,@DPTR ;FWRITE
	inc  DPS
	movx A,@DPTR ;PINSC
	inc  DPS
;
	pop  DPL
	dec  DPH   ;7F->7E == #HIGH IN2BUF
	movx @DPTR,a
	inc  DPL
	djnz r7,WriteReadBI
WriteReadE:
;
	pop	DPH1
	pop	DPL1
;
	ret
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; void WriteX(void);
;
; Trasnmit AUTODATAxOUT2BC
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
WriteX:
	mov  DPTR,#OUT2BC
	movx A,@DPTR
	mov  DPTR,#AUTODATA
;
	mov  r6,a   ;save
	RRC  A
	RRC  A
	RRC  A
	ANL  A,#01FH
	JZ   WriteL
	mov  r7,A
;----- x8 bytes -----
WriteBY:
	movx A,@DPTR
	movx A,@DPTR
	movx A,@DPTR
	movx A,@DPTR
	movx A,@DPTR
	movx A,@DPTR
	movx A,@DPTR
	movx A,@DPTR
	djnz r7,WriteBY
;----- Last 1-7 bytes -----
WriteL:
	mov  A,r6
	ANL  A,#07H
	JZ   WriteE
	mov  r7,A
WriteBI:
	movx A,@DPTR
	djnz r7,WriteBI
WriteE:
	ret
;
	end
